1000 REMark CT_REPORT - Main Reporting module for Cash Trader
1010 :
1020 REMark         Chas Dillon, Apr 87
1030 :
1040 DATA_AREA 10
1050 :
1060 IMPLICIT% ii, jj, kk, qq, rng_min, rng_max, rng_sel, st, nd
1070 IMPLICIT% yr, dy, hr, repno, ors, key, filno, offset
1080 :
1090 WHEN ERRor
1100   WINDOW 258,70,120,70 : BORDER 1,0 : PAPER 4 : INK 0
1110   CLS : PRINT \' An error has occurred ... (';ERNUM%!!ERLIN%;')'
1120   PRINT ' Please check correct volumes are loaded'
1130   PRINT ' and ';drive2$;' is write enabled'
1140   PRINT \'   Press ENTER to retry; ESC to quit'
1150   Get_Key : IF exception : STOP
1160   RETRY
1170   END WHEN
1180 :
1190 DIM vers$(10) : vers$ = "CTver 3.2"
1200 :
1210 DIM drive1$(6), drive2$(6), cart$(6), prtr$(8), file$(20)
1220 DIM f$(2),n$(70),z$(70)
1230 DIM fullname$(36),example$(4),name$(36),last$(20),create$(20),vatno$(20)
1240 DIM nextvat$(20), eoy$(20), form$(6), extract$(10), vfq$(6)
1250 DIM prin$(6), lastvat$(20), doc_date$(12), doc_reftxt$(12)
1260 DIM last_used_doc_date$(12)
1270 :
1280 money_fieldsize% = 10
1290 para_base = 164260 : addr = PEEK_L(para_base)
1300 :
1310 drive1$ = Pull_Up$(4)&"_"
1320 drive2$ = Pull_Up$(4)&"_"
1330 cart$   = Pull_Up$(4)
1340 prtr$   = Pull_Up$(8)
1350 tran_lim_max% = PEEK_W(addr)
1360 anal_lim_max% = PEEK_W(addr+2)
1370 grup_lim_max% = PEEK_W(addr+4)
1380 vatf_lim_max% = PEEK_W(addr+6)
1390 lines_per_doc_max% = PEEK_W(addr+8)
1400 :
1410 REMark >>> _______________  Figurative Constants  ___________________
1420 :
1430 lf_arrow% = 192 : rt_arrow% = 200 : up_arrow% = 208 : dn_arrow% = 216
1440 ctrl_lf%  = 194 : ctrl_rt%  = 202 : del_lf%   = 194
1450 F1_key%   = 232 : F2_key%   = 236 : ENTER%    = 10  : ESC%      = 27
1460 :
1470 REMark >>> __________________________________________________________
1480 :
1490 DIM rept_grp$(6,19),rg(7),op$(15,16),m$(12,9)
1500 DIM options$(5,25)
1510 DIM grup_desc$(grup_lim_max%,15)
1520 DIM grup_rept%(grup_lim_max%), grup_popl%(grup_lim_max%)
1530 DIM grup_max_popl%(grup_lim_max%), grup_total(grup_lim_max%)
1540 DIM anal_blnc(anal_lim_max%), anal_desc$(anal_lim_max%,15)
1550 DIM anal_vtcd%(anal_lim_max%), anal_price%(anal_lim_max%)
1560 DIM vatf_pcnt(vatf_lim_max%), vatf_desc$(vatf_lim_max%,4)
1570 DIM vatf_gros(vatf_lim_max%), vatf_vat(vatf_lim_max%)
1580 DIM vatf_rate$(3,8)
1590 DIM doci_val(lines_per_doc_max%),doci_com$(lines_per_doc_max%,20)
1600 DIM doci_anl%(lines_per_doc_max%),doci_vcd%(lines_per_doc_max%)
1610 :
1620 OPEN #14,'con' : IF COMPILED : OPEN #1,'scr'
1630 :
1640 RETRY_HERE
1650 :
1660 OPEN_IN #5,drive2$&"ct_register"
1670 INPUT #5,fullname$, example$, name$, last$, create$, vatno$
1680 CLOSE #5
1690 :
1700 DATA "Unspec. CASH","CHEQUE......","STNDNG ORDER","DIRECT DEBIT","TRANSFER....","INTEREST....","BANK CHARGES","UNPAID CHQUE","   PAID   ","ADJUSTMENT"," RECEIVED ","BOUGHT  CR"," SOLD  CR ","ACCEPT THIS LINE","DELETE THIS LINE","ENTER MORE LINES"
1710 DATA "SALES..............","COST OF SALES......","OVERHEADS..........","FIXED ASSETS.......","CAPITAL EMPLOYED...","CRNT ASSET/LIABILITY"
1720 DATA "January","February","March","April","May","June","July","August","September","October","November","December"
1730 DATA " VAT Report Print "," Documents Review "," Profit & Loss A/C Print "," Balance Sheet Print "," Trial Balance Print "," Exit to Main Menu"
1740 :
1750 RESTORE
1760 FOR ii=0 TO 15 : READ op$(ii)
1770 FOR ii=1 TO 6  : READ rept_grp$(ii)
1780 FOR ii=1 TO 12 : READ m$(ii)
1790 FOR ii=0 TO 5  : READ options$(ii)
1800 :
1810 Setup_Analysis_Tables
1820 Show_Menu
1830 Produce_Report
1840 :
1850 Set_PapInk : CLS
1860 CLOSE #3 : CLOSE #9 : IF COMPILED : CLOSE #1
1870 STOP
1880 :
1890 DEFine PROCedure Setup_Analysis_Tables
1900 LOCal ii
1910   OPEN_IN #5,drive2$&"ct_paramfile"
1920   INPUT #5,nextvat$, eoy$, printlines, form$, extract$, vfq$
1930   INPUT #5,prin$, lastvat$, vatclear, vatdoc : CLOSE #5
1940   Identify_File 2 : OPEN_IN #5,file$ : INPUT #5,n$
1950   FOR ii=1 TO grup_lim_max%
1960     INPUT #5,n$ : n$ = n$ & "0000"
1970     grup_desc$(ii)=n$(1 TO 15) : grup_rept%(ii)=n$(16)
1980     grup_popl%(ii)=n$(17 TO 19) : grup_max_popl%(ii) = n$(20 TO 22)
1990     END FOR ii : CLOSE #5
2000   Identify_File 3 : OPEN_IN #5,file$ : INPUT #5,n$
2010   FOR ii=1 TO Active_Heads%
2020     INPUT #5,n$ : n$ = n$ & "00000"
2030     anal_desc$(ii)=n$(1 TO 15) : anal_vtcd%(ii)=n$(16)
2040     anal_blnc(ii)=n$(17 TO 26) : anal_price%(ii) = n$(27 TO 31)
2050     END FOR ii : CLOSE #5
2060   Identify_File 4 : OPEN_IN #5,file$
2070   FOR ii=0 TO vatf_lim_max%
2080     INPUT #5,n$
2090     vatf_pcnt(ii)=n$(1 TO 5) : vatf_desc$(ii)=n$(6 TO 9)
2100     vatf_gros(ii)=n$(10 TO 19) : vatf_vat(ii)=n$(20 TO)
2110     END FOR ii
2120   INPUT #5,n$
2130   last_used_doc_date$=n$(1 TO 9) : doc_ct%=n$(10 TO 13) : tran_ct%=n$(14 TO 17)
2140   INPUT #5,n$
2150   FOR ii=0 TO 3 : vatf_rate$(ii)=n$((ii*8)+1 TO (ii*8)+8)
2160   CLOSE #5 : grup_desc$(0)="COMMENT ONLY..."
2170   END DEFine
2180 :
2190 DEFine PROCedure Identify_File(filno)
2200   SELect ON filno
2210     =1 : file$="ct_transact_dat" : rec_lenf%=35
2220     =2 : file$="ct_group_dat"    : rec_lenf%=22
2230     =3 : file$="ct_analysis_dat" : rec_lenf%=31
2240     =4 : file$="ct_vatfile_dat"  : rec_lenf%=29
2250     =5 : file$="ct_header_dat"   : rec_lenf%=60
2260     =REMAINDER : CLS : PRINT "wrong filenumber" : STOP
2270     END SELect
2280   file$=drive2$&file$
2290   END DEFine
2300 :
2310 DEFine FuNction Analysis_Base%(grp%)
2320 LOCal ii, jj
2330   jj = 1
2340   FOR ii=1 TO grp%-1 : jj = jj + grup_max_popl%(ii)
2350   RETurn jj
2360   END DEFine
2370 :
2380 DEFine FuNction Active_Heads%
2390 LOCal ii, jj
2400   jj = 0
2410   FOR ii=1 TO grup_lim_max% : jj = jj + grup_max_popl%(ii)
2420   RETurn jj
2430   END DEFine
2440 :
2450 DEFine PROCedure Reset_PapInk
2460   PAPER 0 : INK 7
2470   END DEFine
2480 :
2490 DEFine PROCedure Set_PapInk
2500   PAPER 2 : INK 7
2510   END DEFine
2520 :
2530 DEFine PROCedure Produce_Report
2540   OPEN #9,'scr' : WINDOW #9,312,20,106,236 : PAPER #9,4 : INK #9,0
2550   REPeat reploop
2560     WINDOW 204,124,214,89 : PAPER 0,4 : CLS
2570     WINDOW 204,124,204,79 : BORDER 1,0
2580     WINDOW 200,122,206,80 : BORDER 3,7 : PAPER 2 : INK 0 : CLS
2590     PRINT #9,"  Use  &  to move indicator.Hit ENTER to accept."
2600     rng_min=0 : rng_max=5 : rng_sel=0
2610     FOR ors=rng_min TO rng_max : Highlight 5
2620     Select_Menu_Option 5,2,0
2630     CLS #9
2640     SELect ON rng_sel
2650       =0 : Report_on_VAT
2660       =1 : Review_Docs
2670       =2 : Print_Profit_Loss
2680       =3 : Print_Bal_Sheet
2690       =4 : Print_Trial_Balance
2700       =5 : EXIT reploop
2710       END SELect
2720     END REPeat reploop
2730   END DEFine
2740 :
2750 DEFine PROCedure Review_Docs
2760 LOCal d1$(60), d2$(60), ii, jj, prtr_op
2770   Reset_PapInk : CLS
2780   d1$="are" : d2$="Documents"
2790   IF doc_ct% = 1 : d1$="is" : d2$="Document"
2800   d1$="There "&d1$&" "&doc_ct% : d2$ = d2$&" on File."
2810   ii=LEN(d1$) : jj=INT((31-ii)/2) : d1$=FILL$(" ",jj)&d1$
2820   ii=LEN(d2$) : jj=INT((31-ii)/2) : d2$=FILL$(" ",jj)&d2$
2830   Reset_PapInk : PRINT d1$\d2$; : Set_PapInk : CLS 2
2840   AT 3,0 : PRINT "Start at which Document "
2850   tr = Input_Value(3, 1, 1, doc_ct%)
2860   IF tr=0 : RETurn
2870   AT 5,0 : PRINT "End at which Document "
2880   te = Input_Value(5, doc_ct%, tr, doc_ct%)
2890   AT 7,0 : PRINT "Screen or Printer (S or P)"
2900   REPeat kn : Get_Key : IF f$ == "S" OR f$ == "P" : EXIT kn
2910   prtr_op=0 : d1$="SCREEN   "
2920   IF f$ == "P" : prtr_op=1 : d1$="PRINTER "
2930   AT 7,18 : PRINT d1$
2940   AT 9,0 : PRINT "Correct Y or N ?"
2950   Wait_for_YN
2960   IF f$ == "N" : Review_Docs : RETurn
2970   d1$ = "Press H to hold or X to abort"
2980   IF prtr_op
2990     OPEN #7,prtr$ : AT 9,0 : PRINT "PRINTING DOCUMENTS" : AT 10,0
3000     PRINT d1$
3010     ELSE
3020     CLOSE #3
3030     WINDOW 512,256,0,0 : PAPER 4 : CLS : OPEN #4,'scr_'
3040     WINDOW #4,426,50,44,5 : BORDER #4,3,7 : PAPER #4,0 : INK #4,7
3050     CLS #4 : PRINT #4,FILL$(" ",20);"PRINTING DOCUMENTS"
3060     AT #4,2,15 : PRINT #4,d1$
3070     OPEN #7,'scr_' : WINDOW #7,426,200,44,55 : BORDER #7,3,2 : PAPER #7,7
3080     PAPER #7,2 : INK #7,7 : CLS #7
3090     PRINT #7,"Doc                     Date             Type"
3100     PRINT #7,"Comment                 Analysis Head    VAT Code   Debit     Credit "
3110     WINDOW #7,426,179,44,77 : BORDER #7,3,2
3120     PAPER #7,7 : INK #7,0 : CLS #7
3130     END IF
3140   Print_Review
3150   IF exception
3160     exception=0
3170     IF prtr_op
3180       PRINT #7,\\"********************** PRINTING ABORTED *****************"
3190       PRINT #7,form$ : CLOSE #7
3200       END IF
3210     END IF
3220   END DEFine
3230 :
3240 DEFine PROCedure Print_Review
3250 LOCal jj, kk, tx$(20)
3260   lin_ct% = 0 : page% = 0
3270   IF prtr_op : Print_Header 2
3280   Position_at_Document tr
3290   FOR jj=tr TO te
3300     Get_Document
3310     IF prtr_op : Checklines
3320     tx$ = "Paid      AdjustmentReceived  Purchase  Sale      "((doc_type%+1)*10+1 TO (doc_type%+1)*10+10)
3330     cr = (doc_type% = -1 OR doc_type% = 2)
3340     PRINT #7,doc_no%;FILL$(" ",4-LEN(doc_no%));"                   ";doc_date$;"         ";tx$
3350     lin_ct% = lin_ct%+1 : exception = 0
3360     FOR kk=1 TO doc_lin_ct%
3370       IF doc_type% = 0 : cr = ( doci_val(kk) >= 0 ) : doci_val(kk)=ABS(doci_val(kk))
3380       PRINT #7,doci_com$(kk);"  ";
3390       IF doci_anl%(kk)<>0
3400         PRINT #7,"  ";anal_desc$(doci_anl%(kk));"  ";vatf_desc$(doci_vcd%(kk));"  ";
3410         IF cr=0 : PRINT #7,"           ";
3420         PRINT #7,Decimal$(doci_val(kk));
3430         END IF
3440       PRINT #7 : lin_ct% = lin_ct%+1 : f$=INKEY$(#14,0)
3450       IF f$=="X" OR f$=="H"
3460         IF f$=="X" : exception=1 : EXIT jj
3470         z$="Press ENTER to Continue       "
3480         IF prtr_op
3490           AT 10,0 : PRINT z$ : ELSE : AT #4,2,15 : PRINT #4,z$
3500           END IF
3510         z$="Press H to hold or X to abort"
3520         Wait_for_ENTER
3530         IF prtr_op
3540           AT 10,0 : PRINT z$ : ELSE : AT #4,2,15 : PRINT #4,z$
3550           END IF
3560         END IF
3570       END FOR kk
3580     IF NOT exception
3590       IF doc_type%<>0
3600         PRINT #7,op$(doc_ref%);"  ";doc_reftxt$;"  ";anal_desc$(doc_acct%);"        ";
3610         IF cr=1 : PRINT #7,"           ";
3620         ELSE
3630         PRINT #7,FILL$("  ",18);doc_reftxt$;FILL$(" ",25);
3640         cr=1 : IF doc_vat<0 : cr=0 : doc_vat=ABS(doc_vat)
3650         END IF
3660       PRINT #7,Decimal$(doc_totvl) : lin_ct% = lin_ct%+1
3670       PRINT #7,FILL$(" ",33);"V.A.T.";FILL$(" ",8);
3680       IF cr=0 : PRINT #7,"           ";
3690       PRINT #7,Decimal$(doc_vat) : PRINT #7,FILL$("-",68+11*(prtr_op<>0)) : lin_ct% = lin_ct%+2
3700       END IF
3710     END FOR jj
3720   CLOSE #10 : CLOSE #11
3730   IF NOT prtr_op
3740     PRINT #7,"Press ENTER to Return to Menu"
3750     Wait_for_ENTER : Show_Menu
3760     ELSE
3770     PRINT #7,form$ : END IF
3780   END DEFine
3790 :
3800 DEFine PROCedure Print_Trial_Balance
3810 LOCal x1, x4, offset, ii, st, nd
3820   Set_up_Report 5
3830   Calc_Total_Stats : x1 = 0 : x4 = 0
3840   FOR jj=1 TO grup_lim_max%
3850     IF grup_popl%(jj) = 0 : NEXT jj : EXIT jj
3860     PRINT #7,\grup_desc$(jj) : lin_ct% = lin_ct%+2
3870     st = Analysis_Base%((jj)) : nd = st+grup_popl%(jj)-1
3880     FOR ii = st TO nd
3890       IF suppress_zero : IF anal_blnc(ii) = 0 : NEXT ii : EXIT ii
3900       PRINT #7,TO 17;anal_desc$(ii);"  ";
3910       IF anal_vtcd%(ii) <> 4
3920         PRINT #7;"(";vatf_desc$(anal_vtcd%(ii));")   ";
3930         ELSE : PRINT #7;"         "; : END IF
3940       offset = 1
3950       IF grup_rept%(jj) = 1 OR grup_rept%(jj) = 5 :  offset = -1
3960       IF (offset * anal_blnc(ii)) < 0
3970         PRINT #7,FILL$(" ",14);
3980         x1 = x1 + ABS(anal_blnc(ii))
3990         ELSE
4000         x4 = x4 + ABS(anal_blnc(ii)) : END IF
4010       PRINT #7,Decimal$(ABS(anal_blnc(ii)))
4020       lin_ct% = lin_ct%+1
4030       IF lin_ct% > printlines-15
4040         PRINT #7,FILL$("-",79)
4050         PRINT #7,"Carried Forward  ";FILL$(" ",26);Decimal$(x4);"    ";Decimal$(x1)
4060         PRINT #7,form$ : Print_Header 5
4070         PRINT #7,"Brought Forward  ";FILL$(" ",26);Decimal$(x4);"    ";Decimal$(x1)
4080         END IF
4090       END FOR ii
4100     END FOR jj
4110   PRINT #7,\FILL$(" ",17);"V.A.T.";FILL$(" ",20);Decimal$(grp_inpvat);"    ";Decimal$(grp_outvat)
4120   PRINT #7,FILL$("-",79)
4130   PRINT #7,FILL$(" ",43);Decimal$(x4+grp_inpvat);"    ";Decimal$(x1+grp_outvat)
4140   PRINT #7,form$ : CLOSE #7
4150   END DEFine
4160 :
4170 DEFine PROCedure Print_Profit_Loss
4180 LOCal ii, jj, kk, qq, w, base%, c(3)
4190   Set_up_Report 3
4200   FOR ii = 1 TO 3 : c(ii) = 0
4210   FOR ii = 1 TO grup_lim_max% : grup_total(ii) = 0
4220   FOR ii = 1 TO 3
4230     Check_Page 1,10,3
4240     PRINT #7,"SALES        COST OF SALESOVERHEADS    "(((ii-1)*13)+1 TO ((ii-1)*13)+13)
4250     FOR jj=1 TO grup_lim_max%
4260       IF grup_rept%(jj)=ii
4270         base% = Analysis_Base%((jj))-1
4280         FOR kk=1 TO grup_popl%(jj)
4290           qq= base% + kk
4300           IF suppress_zero : IF anal_blnc(qq) = 0 : NEXT kk : EXIT kk
4310           Check_Page 1,10,3
4320           PRINT #7,"         ";anal_desc$(qq);"      ";
4330           IF ii=1 : PRINT #7,FILL$(" ",36);
4340           w = anal_blnc(qq)
4350           grup_total(jj) = grup_total(jj)+w : PRINT #7,Decimal$(w)
4360           END FOR kk
4370         Check_Page 1,10,3
4380         IF ii=1 : PRINT #7,FILL$(" ",36);
4390         PRINT #7,FILL$(" ",27);"-------------"
4400         Check_Page 2,10,3
4410         PRINT #7,"     Group:-";grup_desc$(jj);FILL$(" ",18);
4420         IF ii<3 : PRINT #7,FILL$(" ",21);
4430         w = grup_total(jj) : c(ii)=c(ii)+w : PRINT #7,Decimal$(w)
4440         PRINT #7
4450         END IF
4460       END FOR jj
4470     IF ii=3 : Check_Page 1,10,3 : PRINT #7,FILL$(" ",65);Decimal$(c(ii))
4480     IF ii>1
4490       Check_Page 2,10,3
4500       PRINT #7,FILL$(" ",61);"---------------"\\FILL$(" ",32);
4510       END IF
4520     IF ii=2
4530       w=c(1)-c(2) : PRINT #7,"GROSS ";
4540       IF w < 0
4550         PRINT #7,"Loss   "; : ELSE : PRINT #7,"Profit "; : END IF
4560       PRINT #7,FILL$(".",19);"  ";Decimal$(ABS(w))\\\
4570       Check_Page 3,10,3
4580       END IF
4590     IF ii=3
4600       Check_Page 1,10,3
4610       w=c(1)-c(2)-c(3) : PRINT #7," NET ";
4620       IF w<0
4630         PRINT #7,"Loss    "; : ELSE : PRINT #7,"Profit  "; : END IF
4640       PRINT #7,FILL$(".",18);"  ";Decimal$(ABS(w))
4650       END IF
4660     END FOR ii
4670   PRINT #7,\form$ : CLOSE #7
4680   END DEFine
4690 :
4700 DEFine PROCedure Print_Bal_Sheet
4710 LOCal w, ii, jj, kk, offset, np, qq, q$(20)
4720   Set_up_Report 4 : Calc_Total_Stats
4730   FOR ii = 4, 6, 7, 5
4740     SELect ON ii
4750       = 4 : PRINT #7,"FIXED ASSETS"
4760       = 6 : PRINT #7,"CURRENT.................  ASSETS / LIABILITIES"
4770       = 5 : PRINT #7,"CAPITAL EMPLOYED"
4780       END SELect
4790     IF ii<>7 : PRINT #7 : Check_Page 2,10,4
4800 :
4810     REMark *** Reporting Categories  4 = Fixed Assets
4820     REMark                           6 = Current Assets
4830     REMark                           7 = Current Liabilities
4840     REMark                           5 = Capital
4850 :
4860     FOR jj = 1 TO grup_lim_max%
4870       IF grup_rept%(jj)=ii
4880         base% = Analysis_Base%((jj))-1
4890         FOR kk = 1 TO grup_popl%(jj)
4900           qq = base% + kk
4910           IF suppress_zero : IF anal_blnc(qq) = 0 : NEXT kk : EXIT kk
4920           Check_Page 1,10,4
4930           PRINT #7,"     ";anal_desc$(qq);" ";
4940           offset = 1
4950           IF ii = 5 : offset = -1
4960           IF (offset * anal_blnc(qq)) < 0 : PRINT #7,FILL$(" ",14);
4970           IF ii=6
4980             IF anal_blnc(qq)<>0 : PRINT #7,Decimal$(ABS(anal_blnc(qq)));
4990             PRINT #7
5000             ELSE
5010             IF ii=4 : PRINT #7,FILL$(" ",22);
5020             PRINT #7,Decimal$(ABS(anal_blnc(qq)))
5030             END IF
5040           END FOR kk
5050         END IF
5060       END FOR jj
5070     IF ii=7
5080       Check_Page 4,10,4
5090       IF balvat_cat%=7 : q$="VAT Payable    " : ELSE : q$="VAT Repayable  "
5100       PRINT #7,\"     ";q$;" ";
5110       IF balvat_cat%=7 : PRINT #7,"              ";
5120       IF balvat<>0 : PRINT #7,Decimal$(ABS(balvat));
5130       PRINT #7,\FILL$(" ",21);FILL$("-",25)
5140       PRINT #7,"     TOTAL.......... ";Decimal$(ABS(rg(6)));"    ";Decimal$(ABS(rg(7)))
5150       Check_Page 6,10,4
5160       PRINT #7,\\"NET CURRENT "; : w=rg(6)+rg(7)
5170       kk = (w<0)*17
5180       PRINT #7,"ASSETS...........LIABILTIES......."(kk+1 TO kk+17);FILL$(" ",39);Decimal$(w)
5190       PRINT #7,FILL$(" ",68);"-----------"
5200       PRINT #7,FILL$(" ",68);Decimal$(rg(4)+w)
5210       PRINT #7,FILL$(" ",68);"-----------" : PRINT #7 : PRINT #7
5220       ELSE
5230       IF ii<>6
5240         Check_Page 4,10,4
5250         PRINT #7,FILL$(" ",34);
5260         IF ii=4 : PRINT #7,FILL$(" ",22);
5270         PRINT #7,FILL$("-",23)
5280         PRINT #7,FILL$(" ",46);
5290         IF ii=4 : PRINT #7,FILL$(" ",22);
5300         w=ABS(rg(ii)) : PRINT #7,Decimal$(w) : PRINT #7 : PRINT #7
5310         END IF
5320       END IF
5330     END FOR ii
5340   Check_Page 4,10,4
5350   np = rg(1)-rg(2)-rg(3) : w = rg(4) + rg(6) + rg(7)
5360   IF np < 0 : q$="NET LOSS  " : ELSE : q$="NET PROFIT"
5370   PRINT #7,\q$&"     From Profit & Loss Account     ";Decimal$(np)
5380   PRINT #7,FILL$(" ",46);FILL$("-",33)
5390   PRINT #7,\FILL$(" ",46);Decimal$(rg(5)+np);FILL$(" ",12);Decimal$(w)
5400   PRINT #7,FILL$(" ",46);FILL$("-",33)
5410   PRINT #7,\form$ : CLOSE #7
5420   END DEFine
5430 :
5440 DEFine PROCedure Report_on_VAT
5450 LOCal kp,ii,x
5460   Set_up_Report 1 : Calc_Total_Stats
5470   PRINT #7,FILL$(" ",24);"|";FILL$(" ",12);"OUTPUTS         |             INPUTS"
5480   Print_Mask
5490   PRINT #7,FILL$(" ",17);"Rate   |      Goods           VAT   |      Goods           VAT"
5500   PRINT #7,FILL$("-",24);"+";FILL$("-",28);"+";FILL$("-",25)
5510   FOR ii=0,1,3,2
5520     Print_Mask
5530     PRINT #7,FILL$(" ",8-LEN(vatf_rate$(ii)));vatf_rate$(ii);
5540     PRINT #7,"   ";Decimal$(vatf_pcnt(ii));"%  | ";
5550     PRINT #7,Decimal$(vatf_gros(ii));"    ";Decimal$(vatf_vat(ii));"   | ";
5560     PRINT #7,Decimal$(vatf_gros(ii+5));"    ";Decimal$(vatf_vat(ii+5))
5570     Print_Mask
5580     IF ii<>2
5590       PRINT #7,FILL$("-",24);"+";FILL$("-",28);"+";FILL$("-",25) : ELSE
5600       PRINT #7,FILL$("=",79) : END IF
5610     END FOR ii
5620   Print_Mask
5630   PRINT #7,"Value of Outputs";FILL$(" ",8);"| ";Decimal$(grp_outgrs);FILL$(" ",17);"|"
5640   PRINT #7,"Value of Output Tax";FILL$(" ",5);"|               ";Decimal$(grp_outvat);"   |"
5650   Print_Mask
5660   PRINT #7,"Value of Inputs";FILL$(" ",9);"|";FILL$(" ",28);"| ";Decimal$(grp_inpgrs)
5670   PRINT #7,"Value of Input Tax";FILL$(" ",6);"|";FILL$(" ",28);"|               ";Decimal$(grp_inpvat)
5680   Print_Mask
5690   kp=ABS(ntp)
5700   IF ntp<0 : PRINT #7;"Net Tax Repayable"; : ELSE : PRINT #7;"Net Tax Payable  ";
5710   z$ = "       |"&FILL$(" ",28)&"|"&FILL$(" ",25)
5720   x=24 : IF ntp<0 : x=53
5730   z$(x TO x+9)=Decimal$(kp) : PRINT #7,z$
5740   Print_Mask
5750   PRINT #7,FILL$("-",79)
5760   PRINT #7,\\\"These figures could include Documents that do not relate to this current VAT    Period."
5770   PRINT #7,"DO NOT use these figures for completing your VAT Return !!"
5780   PRINT #7,\"To obtain VAT Return Information, select SECURITIES from the Main Menu."
5790   PRINT #7,\FILL$("-",79)
5800   PRINT #7,\"Previous Period Balance Owed ";
5810   IF anal_blnc(1)<0 : PRINT #7,"to "; : ELSE : PRINT #7,"from "; : END IF
5820   PRINT #7,"Customs & Excise is ";Decimal$(ABS(anal_blnc(1)))
5830   PRINT #7,\FILL$("-",79) : PRINT #7,form$
5840   END DEFine
5850 :
5860 DEFine PROCedure Print_Mask
5870   PRINT #7,FILL$(" ",24);"|";FILL$(" ",28);"|"
5880   END DEFine
5890 :
5900 DEFine PROCedure Set_up_Report (repno)
5910   Set_PapInk : CLS
5920   IF repno <> 1
5930     AT 3,0 : PRINT "Suppress ZERO items Y or N"
5940     Wait_for_YN
5950     suppress_zero = (f$ == 'y')
5960     END IF
5970   AT 5,10 : PRINT "PLEASE WAIT"
5980   AT 7, 1 + (21-LEN(Report_Name$(repno)))/2
5990   PRINT "PRINTING ";Report_Name$(repno) : page% = 0
6000   OPEN #7,prtr$ : Print_Header repno
6010   END DEFine
6020 :
6030 DEFine FuNction Report_Name$(repno)
6040   SELect ON repno
6050     =1 : RETurn "VAT REPORT"
6060     =2 : RETurn "DOCUMENT REPORT"
6070     =3 : RETurn "PROFIT & LOSS ACCOUNT"
6080     =4 : RETurn "BALANCE SHEET"
6090     =5 : RETurn "TRIAL BALANCE"
6100     END SELect
6110   END DEFine
6120 :
6130 DEFine PROCedure Checklines
6140   IF (lin_ct%+doc_lin_ct%+2)<printlines-13 : RETurn
6150   PRINT #7,form$ : Print_Header 2
6160   END DEFine
6170 :
6180 DEFine PROCedure Check_Page(add%, subt%, repno)
6190   lin_ct% = lin_ct% + add%
6200   IF lin_ct% > (printlines - subt%)
6210     PRINT #7; form$;
6220     Print_Header repno : lin_ct% = add%
6230     END IF
6240   END DEFine
6250 :
6260 DEFine PROCedure Print_Header(repno)
6270 LOCal ii, yr, dy, hr
6280 LOCal z$(20), dayth$(4), part$(6), rep_type$(24)
6290   rep_type$ = Report_Name$(repno)
6300   ii=INT((75-LEN(rep_type$)-LEN(fullname$))/2)
6310   z$=DATE$ : PRINT #7,FILL$(" ",ii);rep_type$;" for ";fullname$
6320   PRINT #7,\"Printed on ";
6330   yr=z$(1 TO 4) : : hr=z$(13 TO 14)
6340   part$="a.m." : IF hr>12 : hr=hr-12 : part$="p.m."
6350   ii = z$(11)
6360   dy = z$(10 TO 11)
6370   SELect ON ii
6380     =1 : dayth$="st." : IF dy=11 : dayth$="th."
6390     =2 : dayth$="nd." : IF dy=12 : dayth$="th."
6400     =3 : dayth$="rd." : IF dy=13 : dayth$="th."
6410     =REMAINDER : dayth$="th."
6420     END SELect
6430   PRINT #7,dy;dayth$;" ";z$(6 TO 8);" ";yr;FILL$(" ",33);"Time ";hr;":";z$(16 TO 17);" ";part$
6440   PRINT #7 : page% = page% + 1
6450   SELect ON repno
6460     =2 : PRINT #7,"From Document Number ";tr;" to ";te;FILL$(" ",40);"Page ";page%
6470          PRINT #7,FILL$("-",79)
6480          PRINT #7,"Doc                     Date             Type"
6490          PRINT #7,"Comment                 Analysis Head    VAT Code   Debit     Credit "
6500     =1 : PRINT #7,\"VAT Number .... ";vatno$(1 TO 3);" ";vatno$(4 TO 7);" ";vatno$(8 TO)
6510          PRINT #7,\"Up to Document Number ";doc_ct%;FILL$(" ",34);"Period - ";nextvat$
6520     =5 : PRINT #7,"Up to Document Number ";doc_ct%;FILL$(" ",44);"Page ";page%
6530          PRINT #7,FILL$("-",79)
6540          PRINT #7,"Group            Analysis         (VAT)       Debit         Credit"
6550     =REMAINDER : PRINT #7,"Up to Document Number ";doc_ct%;FILL$(" ",44);"Page ";page%
6560     END SELect
6570   PRINT #7,FILL$("-",79)
6580   lin_ct%=0
6590   END DEFine
6600 :
6610 DEFine PROCedure Calc_Total_Stats
6620 LOCal st, nd, kk, ii, jj
6630   grp_inpgrs = 0 : grp_outvat = 0 : grp_inpvat = 0 : grp_outgrs = 0
6640   FOR ii = 0 TO 3
6650     grp_outgrs = grp_outgrs+vatf_gros(ii)
6660     grp_outvat = grp_outvat+vatf_vat(ii)
6670     grp_inpgrs = grp_inpgrs+vatf_gros(ii+5)
6680     grp_inpvat = grp_inpvat+vatf_vat(ii+5)
6690     END FOR ii
6700   ntp = grp_outvat - grp_inpvat
6710   FOR ii = 1 TO 7 : rg(ii) = 0
6720   FOR ii = 1 TO grup_lim_max%
6730     IF grup_popl%(ii)<>0
6740       st = Analysis_Base%((ii)) : nd = st+grup_popl%(ii)-1
6750       FOR jj = st TO nd
6760         kk = grup_rept%(ii)
6770         IF kk = 6 AND anal_blnc(jj)<0 : kk = 7
6780         rg(kk) = rg(kk)+anal_blnc(jj)
6790         END FOR jj
6800       END IF
6810     END FOR ii
6820   balvat = grp_inpvat-grp_outvat
6830   kk = 6 + (balvat < 0)
6840   rg(kk) = rg(kk) + balvat : balvat_cat% = kk
6850   END DEFine
6860 :
6870 DEFine PROCedure Get_Document
6880 LOCal ii
6890   INPUT #10,n$
6900   doc_date$=n$(1 TO 9) : doc_type%=n$(10 TO 11) : doc_acct%=n$(12 TO 15)
6910   doc_ref%=n$(16) : doc_reftxt$=n$(17 TO 24) : doc_no%=n$(25 TO 28)
6920   doc_totvl=n$(29 TO 38) : doc_vat=n$(39 TO 48) : doc_first%=n$(49 TO 52)
6930   doc_lin_ct%=n$(53 TO 55)
6940   FOR ii=1 TO doc_lin_ct%
6950     INPUT #11,n$
6960     doci_val(ii)  =n$(1 TO 10)  : doci_com$(ii)=n$(11 TO 30)
6970     doci_anl%(ii) =n$(31 TO 33) : doci_vcd%(ii)=n$(34 TO 35)
6980     END FOR ii
6990   END DEFine
7000 :
7010 DEFine PROCedure Position_at_Document(begin)
7020 LOCal x
7030   Identify_File 5 : OPEN #10,file$
7040   BGET #10\(begin*(rec_lenf%+1)) : INPUT #10,n$ : x=n$(49 TO 52)
7050   BGET #10\(begin*(rec_lenf%+1))
7060   Identify_File 1 : OPEN #11,file$ : BGET #11\(x*(rec_lenf%+1))
7070   END DEFine
7080 :
7090 DEFine PROCedure Select_Menu_Option(col%,paph%,inkh%)
7100 LOCal ors
7110   REPeat smo_lp
7120     ors = rng_sel
7130     Reset_PapInk : Highlight col%
7140     Get_Key
7150     IF key = ENTER% AND NOT exception : EXIT smo_lp
7160     Adj_Selection options$
7170     PAPER paph% : INK inkh% : Highlight col%
7180     END REPeat smo_lp
7190   END DEFine
7200 :
7210 DEFine PROCedure Highlight(col%)
7220   AT ((ors-rng_min)*2),col% : PRINT options$(ors)
7230   END DEFine
7240 :
7250 REFERENCE array$(0,0)
7260 DEFine PROCedure Adj_Selection(array$)
7270 LOCal ii, jj
7280   SELect ON key
7290     = lf_arrow%, up_arrow% : rng_sel=rng_sel-1
7300                              IF rng_sel<rng_min : rng_sel=rng_max
7310                              RETurn
7320     = rt_arrow%, dn_arrow% : rng_sel=rng_sel+1
7330                              IF rng_sel>rng_max : rng_sel=rng_min
7340                              RETurn
7350     END SELect
7360   FOR ii = rng_sel+1 TO rng_max
7370     IF Found_Option_Match : rng_sel = ii : RETurn
7380     END FOR ii
7390   FOR ii = rng_min TO rng_sel-1
7400     IF Found_Option_Match : rng_sel = ii : RETurn
7410     END FOR ii
7420   END DEFine
7430 :
7440 DEFine FuNction Found_Option_Match
7450   jj = 0
7460   REPeat fom_lp
7470     jj=jj+1 : IF jj > LEN(array$(ii)) : RETurn 0
7480     IF array$(ii,jj)<>" " : EXIT fom_lp
7490     END REP fom_lp
7500   RETurn CHR$(key) == array$(ii,jj)
7510   END DEFine
7520 :
7530 DEFine FuNction Input_Value(lin%,dflt%,minvl%,maxvl%)
7540   REPeat kl
7550     Reset_PapInk
7560     AT lin%,24 : PRINT "    "
7570     AT lin%,24 : Get_String 1,4
7580     x=LEN(z$) : IF x<4 : x=4
7590     Set_PapInk : AT lin%,24 : PRINT FILL$(" ",x) : x = z$
7600     IF x = 0 : x = dflt%
7610     IF Within( x, minvl%, maxvl% ) : EXIT kl
7620     END REPeat kl
7630   AT lin%, 24 : PRINT x : RETurn x
7640   END DEFine
7650 :
7660 DEFine PROCedure Get_String(type,lenf%)
7670   z$=""
7680   REPeat oblp
7690     Get_Kbd_Char type
7700     IF key = ENTER% : EXIT oblp
7710     IF LEN(z$) < lenf% : z$=z$&f$ : PRINT f$;
7720     END REPeat oblp
7730   IF z$=""
7740     IF type=1 : z$="0" : ELSE : z$=" " : END IF
7750     END IF
7760   END DEFine
7770 :
7780 DEFine PROCedure Get_Key
7790   exception = 0
7800   f$ = INKEY$(#14,-1) : key = CODE(f$)
7810   IF key = ESC% : key = ENTER% : f$=CHR$(ENTER%) : exception=1
7820   END DEFine
7830 :
7840 DEFine PROCedure Wait_for_YN
7850   REPeat wyn : Get_Key : IF f$ INSTR "YN" : EXIT wyn
7860   END DEFine
7870 :
7880 DEFine PROCedure Wait_for_ENTER
7890   REPeat wfe : Get_Key : IF key = ENTER% : EXIT wfe
7900   END DEFine
7910 :
7920 DEFine PROCedure Get_Kbd_Char(ii)
7930   REPeat meyloop
7940     Get_Key : IF key = ENTER% : EXIT meyloop
7950     SELect ON ii
7960       =1 : IF Within(key, 48, 57)  : EXIT meyloop
7970       =2 : IF Within(key, 32, 127) : EXIT meyloop
7980       END SELect
7990     END REPeat meyloop
8000   END DEFine
8010 :
8020 DEFine PROCedure Show_Menu
8030 LOCal ii, jj, x$(60)
8040   WINDOW 512,256,0,0 : PAPER 4 : CLS
8050   SCALE 110,0,0 : WINDOW 256,125,20,9 : Draw_Logo
8060   INK 7
8070   WINDOW 302,42,166,20 : PAPER 0,4 : CLS
8080   WINDOW 302,42,156,10 : BORDER 1,0
8090   WINDOW 298,40,158,11 : BORDER 3,2 : PAPER 7 : INK 0 : CLS
8100   CSIZE 2,0 : PRINT " Cash Trader  with VAT" : CSIZE 0,0
8110   ii=47-LEN(fullname$) : jj=INT(ii/2)
8120   x$=FILL$(" ",jj)&fullname$&FILL$(" ",ii-jj)
8130   PRINT \x$
8140   Set_Window_3 1 : CLOCK #3
8150   END DEFine
8160 :
8170 DEFine PROCedure Set_Window_3 (small)
8180   OPEN #3,'scr_'
8190   WINDOW #3,139,42,59,120 : PAPER #3,0,4 : CLS #3
8200   WINDOW #3,139,42,51,110 : BORDER #3,1,7 : PAPER #3,2,0,1 : CLS #3
8210   WINDOW #3,119,22,61,120 : BORDER #3,1,7 : PAPER #3,0 : INK #3,7
8220   CLS #3
8230   IF small : WINDOW #3,60,20,91,121
8240   END DEFine
8250 :
8260 DEFine PROCedure Draw_Logo
8270   INK 4,0 : FILL 1 : CIRCLE 35,82,20
8280   INK 4 : FILL 1 : CIRCLE 35,82,13 : INK 4,0
8290   FILL 1 : LINE 53,61 TO 57,66 TO 48,71 TO 44,66 TO 53,61
8300   FILL 1
8310   LINE 60,101 TO 60,62 TO 87,62 TO 87,68 TO 68,68 TO 68,101 TO 60,101
8320   INK 0 : FILL 1 : CIRCLE 30,85,20
8330   INK 4 : FILL 1 : CIRCLE 30,85,13
8340   INK 0 : FILL 1 : LINE 48,64 TO 52,69 TO 43,74 TO 39,69 TO 48,64
8350   FILL 1 : INK 0
8360   LINE 55,104 TO 55,65 TO 82,65 TO 82,71 TO 63,71 TO 63,104 TO 55,104
8370   INK 4,0 : FILL 0 : FILL 1
8380   ARC 22,75 TO 38,95,-2.2;22,75 TO 38,95,-3.2
8390   FILL 0
8400   END DEFine
8410 :
8420 DEFine FuNction Pull_Up$(lenf%)
8430 LOCal x$(12),ii
8440   x$ = ''
8450   FOR ii = 1 TO lenf% : x$ = x$ & CHR$(PEEK(addr-1+ii))
8460   addr = addr + lenf%
8470   ii = ' ' INSTR x$ : IF ii = 0 : RETurn x$
8480   RETurn x$(1 TO ii-1)
8490   END DEFine
8500 :
8510 DEFine FuNction Decimal$(num)
8520 LOCal x$(12), ii, q, p
8530   q = 100 * num
8540   IF ABS(q) >= .5 : q = INT(ABS(q) + .5) : ELSE : q = 0
8550   p = INT(q/100) : ii = q - p * 100
8560   x$ = p
8570   SELect ON ii
8580     = 0         : x$ = x$ & ".00"
8590     = 1 TO 9    : x$ = x$ & ".0" & ii
8600     = REMAINDER : x$ = x$ & "." & ii
8610     END SELect
8620   IF num < 0 : x$ = '-' & x$
8630   x$ = FILL$(" ",money_fieldsize%-LEN(x$)) & x$
8640   RETurn x$
8650   END DEFine
8660 :
8670 DEFine FuNction Within(val, min, max)
8680   RETurn val >= min AND val <= max
8690   END DEFine
